Bug 60906 - X server will spin on the CPU and eventually crash if up for more than 49 days
X server will spin on the CPU and eventually crash if up for more than 49 days
Product: Red Hat Linux
Classification: Retired
Component: XFree86 (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Mike A. Harris
David Lawrence
Depends On:
  Show dependency treegraph
Reported: 2002-03-08 15:54 EST by Christopher Blizzard
Modified: 2007-04-18 12:40 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2002-03-11 07:42:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
patch (5.17 KB, patch)
2002-03-08 15:54 EST, Christopher Blizzard
no flags Details | Diff
patch from keith packard after sending mine for review (1.52 KB, patch)
2002-03-11 07:42 EST, Christopher Blizzard
no flags Details | Diff

  None (edit)
Description Christopher Blizzard 2002-03-08 15:54:01 EST
Description of Problem:

Version-Release number of selected component (if applicable):

How Reproducible:

Every time

Steps to Reproduce:
1. Set your clock to this date:

date 030701012002

2. Fire up the X server point it at a configured xdm server:

X -query foo

3. Set your date forward in time many days:

date 040402562002

Actual Results:

After a few minutes the X server will start hogging the CPU and will probably
crash or exit after a while with an error:

XDM: Too many retransmissions

Expected Results:

The X server should keep running as normal.

Additional Information:
It appears that after looking at the code that this bit of the code has a very
low tolerance for both clock skew, because someone changed the time, and when
the integer that holds the time rolls over its value.  It's very likely that the
retransmission times for contacting the xdm server will be fully screwed up.

I've got a patch that both adds support for detecting clock skew, and correcting
 from that condition, and handles the rollover of the value correctly.
Comment 1 Christopher Blizzard 2002-03-08 15:54:55 EST
Created attachment 47940 [details]
Comment 2 Mike A. Harris 2002-03-09 10:43:43 EST
FIxed in rawhide, and also pending XFree86 erratum, will be released soon.
Comment 3 Christopher Blizzard 2002-03-09 12:48:23 EST
What version of the XFree86 4.1.x rpms is this present in?
Comment 4 Mike A. Harris 2002-03-10 20:16:22 EST
Comment 5 Christopher Blizzard 2002-03-11 07:42:26 EST
Created attachment 48104 [details]
patch from keith packard after sending mine for review
Comment 6 Mike A. Harris 2002-03-11 08:29:21 EST
Patch updated in 4.1.0-23

Note You need to log in before you can comment on or make changes to this bug.